local Entity = _radiant.om.Entity
local Point3 = _radiant.csg.Point3

local AttackMagicRangedMoveToLOS = class()

AttackMagicRangedMoveToLOS.name = 'attack magic ranged move to targetable location'
AttackMagicRangedMoveToLOS.does = 'stonehearth:combat:attack'
AttackMagicRangedMoveToLOS.args = {
   target = Entity
}
AttackMagicRangedMoveToLOS.version = 2
AttackMagicRangedMoveToLOS.priority = 3
AttackMagicRangedMoveToLOS.weight = 1

local ai = stonehearth.ai
return ai:create_compound_action(AttackMagicRangedMoveToLOS)
   :execute('stonehearth:combat:abort_on_leash_changed')
   :execute('stonehearth:combat:move_to_targetable_location', {
      target = ai.ARGS.target,
   })
   :execute('stonehearth:bump_allies', {
      distance = 2,
   })
   :execute('wizards:combat:attack_magic_ranged', {
      target = ai.ARGS.target,
   })
