wizards = {
   constants = require 'constants'
}

-- TODO(lcai): clean up services; some services like linear combat don't seem to be actively used anymore
local service_creation_order = {
   'combat'
}

local function create_service(name)
   local path = string.format('services.server.%s.%s_service', name, name)
   local service = require(path)()

   local saved_variables = wizards._sv[name]
   if not saved_variables then
      saved_variables = radiant.create_datastore()
      wizards._sv[name] = saved_variables
   end
   service.__saved_variables = saved_variables
   service._sv = saved_variables:get_data()
   saved_variables:set_controller(service)
   service:initialize()
   wizards[name] = service
end

radiant.events.listen(wizards, 'radiant:init', function()
      wizards._sv = wizards.__saved_variables:get_data()
      -- now create all the services
      for _, name in ipairs(service_creation_order) do
         create_service(name)
      end
   end)

return wizards
